#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <string.h>

#include <stdlib.h>
#include "threadp.h"

#include <iostream>
using namespace std;


pthread_mutex_t cond_lock = PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP;

pthread_cond_t hanover_go = PTHREAD_COND_INITIALIZER;
pthread_cond_t norwich_go = PTHREAD_COND_INITIALIZER;

void wait_hanover() {
	pthread_mutex_lock(&cond_lock);
	cond_wait(&hanover_go, &cond_lock, "Hanover Wait.");
	pthread_mutex_unlock(&cond_lock);
}

void wait_norwich() {
	pthread_mutex_lock(&cond_lock);
	cond_wait(&norwich_go, &cond_lock, "Norwich Wait.");
	pthread_mutex_unlock(&cond_lock);
}

void signal_hanover_go() {
	cond_signal(&hanover_go, "Hanover Go!");
}

void signal_norwich_go() {
	cond_signal(&norwich_go, "Norwich Go!");
}


/**
 * Printing functions
 */

void print_status(unsigned long on_bridge, unsigned long to_hanover, unsigned long to_norwich, unsigned long bridge_direction) {

	cout << "***************************************\n";
	cout << "HANOVER\tBRIDGE\tNORWICH\n";
	cout << to_hanover << "\t" << on_bridge << ":"
		 << ((bridge_direction > 0) ? "N" : "H") << "\t" << to_norwich << endl;
	cout << "***************************************\n\n";
}


void print_new_vehicle(unsigned long vehicle_direction) {

	cout << "New*" << (unsigned long)pthread_self() << ": "
		 << ((vehicle_direction > 0) ? "Norwich" : "Hanover") << endl;
}


void print_arrive_bridge(unsigned long vehicle_direction) {

	cout << (unsigned long)pthread_self() << ": "
		 << ((vehicle_direction > 0) ? "Norwich" : "Hanover")
		 << " arrived at bridge *#&@!\n";
}


void print_wait_queue(unsigned long vehicle_direction) {

	cout << (unsigned long)pthread_self() << ": "
		 << ((vehicle_direction > 0) ? "Norwich" : "Hanover")
		 << " jammed in queue!\n";
}


void print_wakeup_queue(unsigned long vehicle_direction) {

	cout << (unsigned long)pthread_self() << ": "
		 << ((vehicle_direction > 0) ? "Norwich" : "Hanover")
		 << " out of jam!\n";
}


void print_on_bridge(unsigned long vehicle_direction) {

	cout << (unsigned long)pthread_self() << ": "
		 << ((vehicle_direction > 0) ? "Norwich" : "Hanover")
		 << " on bridge\n";
}


void print_exit_bridge(unsigned long vehicle_direction) {

	cout << (unsigned long)pthread_self() << ": "
		 << ((vehicle_direction > 0) ? "Norwich" : "Hanover")
		 << " exit bridge and off to "
		 << ((vehicle_direction > 0) ? "Norwich" : "Hanover")
		 << "!!!!\n";
}


void print_serious_error(unsigned long error_code) {

	cout <<"$(#@$#@($@#*($@#(#( SERIOUS ERROR!!! " << error_code << endl;
	exit(-1);
}
