#include <stdlib.h>
#include <time.h>

#include <iostream>
using namespace std;


bool RAND_INITIALIZED = false;

/**
 * Seeds the random number generator with the current time.
 * This should only be called once
 */
void initialize_rand() {

	if (RAND_INITIALIZED)
		return;

	cout << "INITIALIZING RAND";

	time_t seed;
	time(&seed);

	srand(seed);

	RAND_INITIALIZED = true;
}


/**
 * native rand.. since clay does not have rand()
 */
unsigned long rand(unsigned long N) {

	// if we haven't already, seed the random number generator
	if (!RAND_INITIALIZED)
		initialize_rand();

	unsigned long x = (unsigned long)rand()%N;
	cout << N << " Rand X: " << x << endl;
	return x;

	/* // impressive way to do rand()%N
	double r = ((double)rand()/(double)(RAND_MAX+1));
	double x = (r*N);

	cout << " Rand X: " << (unsigned long)x;

	return (unsigned long)x;*/
}
