#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <string.h>

#include <stdlib.h>
#include "threadp.h"

#include <iostream>
using namespace std;


#include "box_native.h"


/**
 * Native pthread stubs.
 * @author Edward Wei, Soumendra Nanda
 */


/**
 * Native stub for pthread api call to create thread
 *
 * function should be a function that takes in a box,
 * and returns void
 */
ClayThreadType create_thread(unsigned long function, ClayBoxType box) {

	int rc;
	pthread_t child;

	void* (*func_ptr)(void*) = (void*(*)(void*))function;

	rc = pthread_create(&child, NULL, func_ptr, (void*)box);

	if (rc) {
		cerr << "thread creation failed!";
		exit(-1);
	}

	// actually, pthread_t IS a unsigned long
	return (unsigned long)child;
}

void waitfor_thread(ClayThreadType thread_handle_ptr) {

	int rc;
	pthread_t thread_handle = (pthread_t)thread_handle_ptr;
	
	rc = pthread_join(thread_handle, NULL);

	if (rc) {
		cerr << "pthread_join: could not waitfor thread";
		exit(-1);
	}
}

/* void create_thread(void* (*function)(ClayBoxType), ClayBoxType box) {

	create_thread((unsigned long)function, box);
} */


void sleep(unsigned long usec) {

	usleep(usec);
}
