#ifndef THREADP_H
#define THREADP_H

#include <pthread.h> // for threads
#include <semaphore.h> // for semaphores

// because some versions of the pthread.h don't match the man pages
#ifndef PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP
#define PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP \
	{0, 0, 0, PTHREAD_MUTEX_ERRORCHECK_NP, __LOCK_INITIALIZER}
#endif

void acquire(pthread_mutex_t *mutexp, char *name);
void release(pthread_mutex_t *mutexp, char *name);

void sem_up(sem_t *semp, char *name);
void sem_down(sem_t *semp, char *name);
int sem_trydown(sem_t *semp, char *name);
void cond_wait(pthread_cond_t *cp, pthread_mutex_t *mp, char *name);
void cond_signal(pthread_cond_t *cp, char *name);
void cond_broadcast(pthread_cond_t *cp, char *name);
 
#endif // THREADP_H
